<?php

// General Settings

$nccsf_options['configuration'] = array(
    array(
        'oid' => 'configuration_heading',
        'oname' => 'Information',
        'otype' => 'heading',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => 'Configuration',
    ),
    array(
        'oid' => 'plugin_status',
        'oname' => 'Coming Soon Page',
        'otype' => 'radio',
        'oinfo' => 'Enable or Disable the Coming Soon Splash Page for this site.',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
    array(
        'oid' => 'site_access',
        'oname' => 'Site Access',
        'otype' => 'users',
        'oinfo' => 'Select who else can access the site front-end even the coming soon page is enabled. <br /> 
                    Admin panel will be displayed as per the user role.',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => array('0'),
    ),
    array(
        'oid' => 'plugin_modules_heading',
        'oname' => 'Modules',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => 'Modules',
    ),
    array(
        'oid' => 'module_content',
        'oname' => 'Custom Message',
        'otype' => 'radio',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
    array(
        'oid' => 'module_countdown',
        'oname' => 'Countdown Timer',
        'otype' => 'radio',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
    array(
        'oid' => 'module_twitter_feeds',
        'oname' => 'Twitter Feed',
        'otype' => 'radio',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
    array(
        'oid' => 'module_social_media_icons',
        'oname' => 'Social Media Icons',
        'otype' => 'radio',
        'oinfo' => '',
        'omenu' => 'modules',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
    array(
        'oid' => 'module_contact_form',
        'oname' => 'Contact Link',
        'otype' => 'radio',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
    array(
        'oid' => 'module_email_subscription',
        'oname' => 'Email Subscriptions',
        'otype' => 'radio',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => array('enable' => 'Enable', 'disable' => 'Disable'),
        'odefault' => 'enable',
    ),
);

// Branding

$nccsf_options['branding'] = array(
    array(
        'oid' => 'branding_heading',
        'oname' => 'Color Scheme',
        'otype' => 'sub-heading',
        'oinfo' => 'Hello',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => 'Color Scheme',
    ),
    array(
        'oid' => 'color_scheme',
        'oname' => 'Default Color Scheme',
        'otype' => 'dropdown',
        'oinfo' => '<p>Choose the default color scheme.</p><p><b>CUSTOM:</b> Update settings under Custom Color Scheme Options</p>',
        'osuffix' => '',
        'ovalue' => array('black' => 'Black', 'blue' => 'Blue', 'red' => 'Red', 'green' => 'Green', 'orange' => 'Orange', 'pink' => 'Pink', 'brown' => 'Brown', 'custom' => 'Custom'),
        'odefault' => 'black',
    ),
    array(
        'oid' => 'logo_heading',
        'oname' => 'Branding',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => 'Logo',
    ),
    array(
        'oid' => 'logo_type',
        'oname' => 'Logo Type',
        'otype' => 'radio',
        'oinfo' => 'Select if you want to show the logo as Text or Image',
        'osuffix' => '',
        'ovalue' => array('text_logo' => 'Text', 'image_logo' => 'Image', 'none' => 'None'),
        'odefault' => 'image_logo',
    ),
    array(
        'oid' => 'logo_text',
        'oname' => 'Logo Text',
        'otype' => 'textbox',
        'oinfo' => 'Type the text to be displayed as logo.',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => 'Company Name',
    ),
    array(
        'oid' => 'logo_image',
        'oname' => 'Logo Image',
        'otype' => 'file',
        'oinfo' => 'Upload the logo image (PNG file recommended)',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => nccsf_product_info('product_url') . '/themes/images/logo.png',
    ),
    array(
        'oid' => 'custom_color_scheme_heading',
        'oname' => 'Custom Color Scheme',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => 'Custom Color Scheme',
    ),
    array(
        'oid' => 'custom_color_scheme',
        'oname' => 'Background Color',
        'otype' => 'color',
        'oinfo' => 'Choose a custom color for background.',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => '2679b1',
    ),
    array(
        'oid' => 'custom_link_color',
        'oname' => 'Link Color',
        'otype' => 'color',
        'oinfo' => 'Choose a custom color for links on the coming soon page.',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => '2277ea',
    ),
);

// Information Page
$nccsf_options['modules'] = array(
    array(
        'oid' => 'modules_heading',
        'oname' => 'Page Content',
        'otype' => 'heading',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => 'Page Content',
    ),
    array(
        'oid' => 'page_title',
        'oname' => 'Page Title',
        'otype' => 'textbox',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => 'Coming Soon',
    ),
    array(
        'oid' => 'page_content',
        'oname' => 'Page Title',
        'otype' => 'wysiwyg',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "<h2>Our website is under-construction!</h2><p>We'll be up and running soon with our new and improved website.</p>",
    ),
    array(
        'oid' => 'countdown_heading',
        'oname' => 'Countdown Timer',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "Countdown Timer",
    ),
    array(
        'oid' => 'launch_date',
        'oname' => 'Launch Date',
        'otype' => 'date',
        'oinfo' => 'Specify the date for the site to be launched.',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "31 Dec, 2011",
    ),
    array(
        'oid' => 'twitter_heading',
        'oname' => 'Twitter Feed',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "Twitter Feed",
    ),
    array(
        'oid' => 'twitter_handle',
        'oname' => 'Twitter ID',
        'otype' => 'textbox',
        'oinfo' => 'Specify your twitter id to call the tweets.',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "netchillies",
    ),
    array(
        'oid' => 'email_subscription_heading',
        'oname' => 'Email Subscriptions',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "Email Subscriptions",
    ),
    array(
        'oid' => 'feedburner_id',
        'oname' => 'Feedburner ID',
        'otype' => 'textbox',
        'oinfo' => 'Enter your feedburner ID to enable email subscriptions via feedburner.com.
                    <p>e.g. http://feeds.feedburner.com/<b>netchillies</b> | In this example <u>netchillies</u> is the ID.</p>',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "netchillies",
    ),
    array(
        'oid' => 'contact_form_heading',
        'oname' => 'Contact',
        'otype' => 'sub-heading',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => "Contact",
    ),
    array(
        'oid' => 'contact_email',
        'oname' => 'Email Address',
        'otype' => 'textbox',
        'oinfo' => 'Enter your email address to be used for the Contact Us Link',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => get_option('admin_email'),
    ),
);


// Information Page
$nccsf_options['info_page'] = array(
    array(
        'oid' => 'item_info',
        'oname' => 'Product Info',
        'otype' => 'heading',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => 'Product Information',
    ),
    array(
        'oid' => 'item_type',
        'oname' => 'Product Type',
        'otype' => 'info',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => 'WordPress ' . nccsf_product_info('item_type'),
    ),
    array(
        'oid' => 'item_name',
        'oname' => 'Product Name',
        'otype' => 'info',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => nccsf_product_info('item_name'),
    ),
    array(
        'oid' => 'terms_of_use',
        'oname' => 'License',
        'otype' => 'info',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => '<p>This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.</p>',
    ),
    array(
        'oid' => 'pro_version',
        'oname' => 'Premium Version',
        'otype' => 'info',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => '<p>Check out the <a target="_blank" href="' . nccsf_product_info('pro_version_url') . '" title="">Premium Version </a> of this product.</p>',
    ),
    array(
        'oid' => 'localization',
        'oname' => 'Localization',
        'otype' => 'info',
        'oinfo' => '',
        'osuffix' => '',
        'ovalue' => '',
        'odefault' => '<p><a target="_blank" href="//http://www.netchillies.com/localize-plugins/" title="">Follow this tutorial </a> to translate this plug-in in your language',
    ),    
    array(
        'oid' => 'help_and_support',
        'oname' => 'Help &amp; Support',
        'otype' => 'info',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => '<a target="_blank" href="http://www.netchillies.com/forums" title="">Support Forums</a> | <a  target="_blank" href="http://www.netchillies.com/contact" title="">Contact Us</a>',
    ),
    array(
        'oid' => 'special_offers',
        'oname' => 'Special Offers',
        'otype' => 'info-yellow',
        'oinfo' => '',
        'osuffix' => 'px',
        'ovalue' => '',
        'odefault' => '<p>Be notified of our special offers/discounts and Win a free license for any of our products every month.</p> 
                       <p>
                           <a href="https://www.facebook.com/NetChillies" target="_blank">Like us on Facebook</a> &bull; 
                           <a href="http://www.twitter.com/netchillies" target="_blank">Follow us on Twitter</a> &bull;
                           <a target="_blank" href="http://eepurl.com/bV_WT" title="">Join our mailing list</a>
                       </p>'),
);